#define PT_USE_TIMER
#define PT_USE_SEM
#include <pt.h>
#include <SoftwareSerial.h>
SoftwareSerial HMI(6, 7); // RX, TX初始化数字端口6,7为软件串口屏幕使用.
/**************************定义变量******************************/
static int uart_data[8] = {0};
static int comm_data[7] = {0};
static int comm_button[8] = {0};
int uart_num = 0;
int comm_len = 0;
int endflag = 0;
static int th_Temperature = 0, th_Time = 0;
static int ag_Temperature = 0, ag_Time = 0;
int Relay1 = 8, Relay2 = 9, Relay3 = 10 , Relay4 = 11;
byte x = 255;

/************************定义PT调用*****************************/
static struct pt Readcom, page0_pt, page1_pt, page2_pt, page3_pt;
static struct pt_sem panduan;
/************************主程序初始化*****************************/
void setup()
{
  Serial.begin(57600);//初始化PC串口
  while (!Serial) {
    ; // 等待串口连接。Needed for Leonardo only
  }
  Serial.println("PCCOM_OK!");
  HMI.begin(9600);// 初始化HMI串口
  HMI.println("HMICOM_OK");
  PT_INIT(&Readcom);
  PT_INIT(&page0_pt);
  PT_INIT(&page1_pt);
  PT_INIT(&page2_pt);
  PT_INIT(&page3_pt);
  PT_SEM_INIT(&panduan, 1);
  pinMode(Relay1, OUTPUT);
  pinMode(Relay2, OUTPUT);
  pinMode(Relay3, OUTPUT);
  pinMode(Relay4, OUTPUT);
}
/*************************循环任务*******************************/
void loop() // 循环
{
  Read_com(&Readcom);
  page1(&page1_pt);
  page2(&page2_pt);
  page3(&page3_pt);
}
/************************读串口数据******************************/
static int Read_com(struct pt*pt)
{
  PT_BEGIN(pt);
  while (1)
  {
    PT_WAIT_UNTIL(pt, HMI.available());
    int inchar = (int)HMI.read();
    delay(2);
    uart_data[uart_num] = inchar;
    uart_num++;
    //Serial.println(uart_data[uart_num]);
    if (inchar == 255)
    {
      endflag++;
      if (endflag == 3)
      {
        if (uart_num == 7)
        {
          for (int i = 0; i < uart_num; i++)
          {
            comm_data[i] = uart_data[i];
            Serial.print(comm_data[i]);//打印7位数组
          }
          Serial.println();
        }
        if (uart_num == 8)
        {
          for (int i = 0; i < uart_num; i++)
          {
            comm_button[i] = uart_data[i];
            Serial.print(comm_button[i]);//打印8位数组
          }
          Serial.println();
        }
        comm_len = uart_num;
        uart_num = 0;
        endflag = 0;
      }
    }
  }
  PT_END(pt);
}
/************************页面1按钮按下事件**************************/
static int page1(struct pt*pt)
{
  PT_BEGIN(pt);
  while (1)
  {
    PT_WAIT_UNTIL(pt, comm_data[0] == 101); //第一位数据类型;
    PT_WAIT_UNTIL(pt, comm_data[1] == 1); //第一位数据,页面ID;
    if (comm_data[2] == 3)
    {
      PT_WAIT_UNTIL(pt, comm_data[2] == 3); //第二位控件ID;
      PT_WAIT_UNTIL(pt, comm_data[3] == 0); //第三位按钮按下事件;
      if (comm_button[0] == 113)
      {
        if (comm_button[1] == 0) //糖化按钮弹起
        {
          Serial.print("up");
          send_end();
          HMI.print("th.n0.val=0");
          send_end();
          PT_TIMER_DELAY(pt, 10);
          HMI.print("th.bt1.val=0");
          send_end();
          PT_TIMER_DELAY(pt, 10);
          th_Temperature = 0; //糖化温度置0
          HMI.print("th.n1.val=0");
          send_end();
          PT_TIMER_DELAY(pt, 10);
          HMI.print("th.bt2.val=0");
          send_end();
          PT_TIMER_DELAY(pt, 10);
          th_Time = 0; //糖化时间置0
          comm_data[1] = { -1}; //清除按钮标志位
        }
        if (comm_button[1] == 1)//糖化按钮按下
        {
          Serial.print("down");
          //          send_end();
          //          HMI.print("page zf");
          //          send_end();
          //          PT_TIMER_DELAY(pt, 10);
          comm_data[1] = { -1}; //清除按钮标志位
        }
      }
    }
    if (comm_data[2] == 4)
    {
      PT_WAIT_UNTIL(pt, comm_data[2] == 4); //第二位控件ID;
      PT_WAIT_UNTIL(pt, comm_data[3] == 0); //第三位按钮按下事件;
      if (comm_button[0] == 113)
      {
        th_Temperature = comm_button[1];
        Serial.print("tanghua_wendu:");
        Serial.println(th_Temperature);//打印测试糖化的温度值.
        comm_data[1] = { -1};
      }
    }
    if (comm_data[2] == 5)
    {
      PT_WAIT_UNTIL(pt, comm_data[2] == 5); //第二位控件ID;
      PT_WAIT_UNTIL(pt, comm_data[3] == 0); //第三位按钮按下事件;
      if (comm_button[0] == 113)
      {
        th_Time = comm_button[1];
        Serial.print("tanghua_shijian:");
        Serial.println(th_Time);//打印测试糖化的时间
        comm_data[1] = { -1};
      }
    }
  }
  PT_END(pt);
}
/************************页面2按钮按下事件**************************/
static int page2(struct pt*pt)
{
  PT_BEGIN(pt);
  while (1)
  {
    PT_WAIT_UNTIL(pt, comm_data[0] == 101); //第一位数据类型;
    PT_WAIT_UNTIL(pt, comm_data[1] == 2); //第一位数据,页面ID;
    if (comm_data[2] == 3)
    {
      PT_WAIT_UNTIL(pt, comm_data[2] == 3); //第二位控件ID;
      PT_WAIT_UNTIL(pt, comm_data[3] == 0); //第三位按钮按下事件;
      if (comm_button[0] == 113)
      {
        if (comm_button[1] == 0) //煮沸按钮弹起
        {
          Serial.print("up");
          send_end();
          HMI.print("zf.n0.val=0");
          send_end();
          PT_TIMER_DELAY(pt, 10);
          HMI.print("zf.bt1.val=0");
          send_end();
          PT_TIMER_DELAY(pt, 10);
          ag_Temperature = 0; //熬煮温度置0
          HMI.print("zf.n1.val=0");
          send_end();
          PT_TIMER_DELAY(pt, 10);
          HMI.print("zf.bt2.val=0");
          send_end();
          PT_TIMER_DELAY(pt, 10);
          ag_Time = 0; //熬煮时间置0
          comm_data[1] = { -1}; //清除按钮标志位
        }
        if (comm_button[1] == 1)//糖化按钮按下
        {
          Serial.print("down");
          //send_end();
          //HMI.print("page relay");
          //send_end();
          PT_TIMER_DELAY(pt, 10);
          comm_data[1] = { -1}; //清除按钮标志位
        }
      }
    }
    if (comm_data[2] == 4)
    {
      PT_WAIT_UNTIL(pt, comm_data[2] == 4); //第二位控件ID;
      PT_WAIT_UNTIL(pt, comm_data[3] == 0); //第三位按钮按下事件;
      if (comm_button[0] == 113)
      {
        ag_Temperature = comm_button[1];
        Serial.print("aozhu_wendu:");
        Serial.println(ag_Temperature);//打印测试糖化的温度值.
        comm_data[1] = { -1};
      }
    }
    if (comm_data[2] == 5)
    {
      PT_WAIT_UNTIL(pt, comm_data[2] == 5); //第二位控件ID;
      PT_WAIT_UNTIL(pt, comm_data[3] == 0); //第三位按钮按下事件;
      if (comm_button[0] == 113)
      {
        ag_Time = comm_button[1];
        Serial.print("aozhu_shijian:");
        Serial.println(ag_Time);//打印测试糖化的时间
        comm_data[1] = { -1};
      }
    }
  }
  PT_END(pt);
}

/************************页面3按钮按下事件**************************/
static int  page3(struct pt * pt)
{
  PT_BEGIN(pt);
  while (1)
  {
    PT_WAIT_UNTIL(pt, comm_data[0] == 101); //第一位数据类型;
    PT_WAIT_UNTIL(pt, comm_data[1] == 3); //第一位数据,页面ID;
    if (comm_data[2] == 3)
    {
      PT_WAIT_UNTIL(pt, comm_data[2] == 3); //第二位数据,控件ID;
      Serial.print("Relay1");
      PT_WAIT_UNTIL(pt, comm_button[0] == 113); //button第0位数据类型,
      if (comm_button[1] == 1) //comm_button第一位为1,开
      {
        digitalWrite(Relay1, HIGH);
        Serial.println("on");
      }
      if (comm_button[1] == 0) //comm_button第一位为0,关
      {
        Serial.println("off");
        digitalWrite(Relay1, LOW);
      }
      comm_data[1] = { -1};
    }
    if (comm_data[2] == 4)
    {
      PT_WAIT_UNTIL(pt, comm_data[2] == 4); //第二位数据,控件ID;
      PT_WAIT_UNTIL(pt, comm_data[3] == 0); //第三位数据,按钮事件;
      Serial.print("Relay2");
      PT_WAIT_UNTIL(pt, comm_button[0] == 113); //button第0位数据类型,
      if (comm_button[1] == 1) //comm_button第一位为1,开
      {
        digitalWrite(Relay2, HIGH);
        Serial.println("on");
      }
      if (comm_button[1] == 0) //comm_button第一位为0,关
      {
        digitalWrite(Relay2, LOW);
        Serial.println("off");
      }
      comm_data[1] = { -1};
    }
    if (comm_data[2] == 5)
    {
      PT_WAIT_UNTIL(pt, comm_data[2] == 5); //第二位数据,控件ID;
      PT_WAIT_UNTIL(pt, comm_data[3] == 0); //第三位数据,按钮事件;
      Serial.print("Relay3");
      PT_WAIT_UNTIL(pt, comm_button[0] == 113); //button第0位数据类型,
      if (comm_button[1] == 1) //comm_button第一位为1,开
      {
        digitalWrite(Relay3, HIGH);
        Serial.println("on");
      }
      if (comm_button[1] == 0) //comm_button第一位为0,关
      {
        digitalWrite(Relay3, LOW);
        Serial.println("off");
      }
      comm_data[1] = { -1};
    }
    if (comm_data[2] == 6)
    {
      PT_WAIT_UNTIL(pt, comm_data[2] == 6); //第二位数据,控件ID;
      PT_WAIT_UNTIL(pt, comm_data[3] == 0); //第三位数据,按钮事件;
      Serial.print("Relay4");
      PT_WAIT_UNTIL(pt, comm_button[0] == 113); //button第0位数据类型,
      if (comm_button[1] == 1) //comm_button第一位为1,开
      {
        digitalWrite(Relay4, HIGH);
        Serial.println("on");
      }
      if (comm_button[1] == 0) //comm_button第一位为0,关
      {
        digitalWrite(Relay4, LOW);
        Serial.println("off");
      }
      comm_data[1] = { -1};
    }
  }
  PT_END(pt);
}
/******************************页面事件**************************/

/*************************写结束符*******************************/
void send_end()
{
  HMI.write(x);
  HMI.write(x);
  HMI.write(x);
}

